/* srelite2 addon to Change SRE2003 BADIP information (HOSTINFO.CFG) */
badipcfg:

USECOLOR='2dd52f'

/* ---------------- DO NOT MODIFY BELOW THIS LINE  ------------------ */


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,user,privset,,
          uri,host_nickname,id_info


if verb="" then do
   say " This sreLite2 add-on is NOT meant to be run from the command line."
   exit
end  

ss=sre_value('SECURITY_LEVEL',,'SRESYS')
if ss=0 then do
  foo=sre_command('String Sorry. Remote access to configuration utilities not permitted.',,idinfo)
  return foo
end
if ss=1 then do
    myaddr=sre_extract("clientaddr",idinfo)
    who=sre_extract("serveraddr",idinfo)
    if myaddr<>who then do
      sfoo=sre_command('String External (not-from-server-machine) web access to configuration utilities is not permitted' ,,idinfo)
      return sfoo
   end
end


signal on error name foo1 ; signal on syntax name foo1

crlf='0d0a'x

list=strip(list)
list=sre_packur(translate(list,' ','+'||'090d0a'x))
if pos('TODO=__MODIFY',list)>0 then signal modifyit

/* else, show values */

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
call lineout tempfile, "<html><head><title>sreLite2 modify SRE2003 UnAllowed IP entries </title>"
call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '
   
call lineout tempfile, "<h2> sreLite2: view and modify SRE2003 UnAllowed IP entries       </h2> <p>"
call lineout tempfile,'<FORM method="POST" action="/system/badipCFG">'
call lineout tempfile,'<Input type="hidden" name="TODO" value="__MODIFY">'
call lineout tempfile,'<TABLE border=1><TR><th>Check to remove</th>'
call lineout tempfile,'<TH>Dotted Numeric IP address</th>'
call lineout tempfile,'<TH>Comment (i.e.; domain name)</th>'

call get_hosts
do mm=1 to entries.0
 clickit='<input type="CHECKBOX" name="REMOVE" value="'entries.mm.!name'">'
   call lineout tempfile,'<tr><td align="center">'clickit'</td>'
   dd1=entries.mm.!name
   parse var dd1 dd cc
   call lineout tempfile,' <td>'dd '</td><td>&nbsp;'cc'</td>'
end
call lineout tempfile,"<tr> <td colspan=4><hr>"
call lineout tempfile,'<tr bgcolor="#8998cc"><th>Add a new UnAllowed IP address:</th>'
call lineout tempfile,'<td colspan=2><input type="text" name="NEWNAME" size=35></td>'

call lineout tempfile,'</table>'
call lineout tempfile,'<input type="checkbox" name="CLEANUP" value=1>Cleanup BADIPS.IN file (remove inactivated entries)'
call lineout tempfile,'<br><input type="SUBMIT" value="Modify UnAllowed IP info"><input type="RESET">'
call lineout tempfile,'</form><br>'
call lineout tempfile,'Notes: <ul> <li> UnAllowed IP entries are stored in: 'badipfile
call lineout tempfile,'<li> You can use * as a wildcard (but only for whole octets) '
call lineout tempfile,'<li> You can enter a (non-wildcarded) domain name -- it will be converted to its IP address '

call lineout tempfile,'<li><a href="/sre2k/SRE2003.htm#cfgunallowedfile" target="SRELITE2_DOC">The SRE2003 manual</a> '
call lineout tempfile,'<li><a href="/sre2k/srelite2/config.htm" >back to configuration page</a>'


call lineout tempfile,' </ul></body></html>'

CALL LINEOUT TEMPFILE
rcode=sre_command('FILE nowait  ERASE TYPE text/html name 'tempfile,,id_info)
return rcode


/* ---------jump here if "set values" chosen */
modifyit:
call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
call lineout tempfile, "<html><head><title>sreLite2: modifying hosts </title>"
call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '
   
call lineout tempfile, "<h2> sreLite2: modifying host entries        </h2> <p>"

remlist=''
NEWNAME=''; newentry=0;cleanup=0
do until list=''
   parse var list a1 '&' list
   parse var  a1 avar '=' aval ;avar=strip(translate(avar))
   aval=strip(translate(sre_packur(aval),' ','+'||'0d0a00901'x))
   if aval='' then iterate
   if avar='REMOVE' then remlist=remlist' '||translate(aval)
   if avar='NEWNAME' & aval<>'' then do
       if words(aval)=1  then do                /* ignore if not 1 word */
          NEWNAME=aval
          newentry=1
       end
       else do
           call lineout tempfile,'<br>Can not process new entry: hostname must not contain spaces '
           newentry=0
       end 
   end
   if avar="CLEANUP" then cleanup=1
end /* do */

call get_hosts

/* remove entries */
nrem=0
do ii=1 to lins.0
   ss2=strip(lins.ii)
   if  abbrev(ss2,';')=1 then iterate
   if lins.ii=' ' then iterate
   parse var ss2  ahost  . ; ahost=strip(translate(ahost))
   if wordpos(ahost,remlist)>0 then do
        call lineout tempfile,' <br>Removing: <tt>'ahost'</tt>'
        lins.ii='; REMOVED '||date('u')||' - 'lins.ii
        nrem=nrem+1
   end 
end 
/* add an entry */

newdname=''
do kk=1 to 1
  if newentry=0 then leave
  if NEWNAME='' then do
       call lineout tempfile,'<br>Can not process new entry: You forgot to enter an IP address'
       newentry=0              
       leave
  end 
  call lineout tempfile,'<br> Adding new entry for:<tt> 'NEWNAME'</tt>'

  if verify(newname,'1234567890.*')>0 then do
     if pos('*',newname)>0 then do
          call lineout tempfile,'<br> Can not process new entry: * (wildcard) in a domain name '
          newentry=0              
          leave
      end
      rc=sockgethostbyname(newname, "serv.0")  /* get dotaddress of server */
      if serv.0addr='SERV.0ADDR' then do
          call lineout tempfile,'<br> Can not process new entry: dns lookup failed for domain name = 'newname
          newentry=0              
          leave
      end 
      newdname=newname
      newname=serv.0addr
      call lineout tempfile,'  (with ip address of ' newname ' )'
  end
  iii=lins.0+1
  if newdname<>'' then 
     lins.iii=newname '  ( 'newdname ' )'
  else
     lins.iii=NEWNAME
  lins.0=iii
end /* do */

/* no changes? */
if cleanup<>1 & newentry<>1 & nrem=0 then do
  call lineout tempfile,'<p>No changes were specified: UnAllowed IP file will not be modified. '
  call lineout tempfile,'</body></html>'
  CALL LINEOUT TEMPFILE
  rcode=sre_command('FILE nowait ERASE nowait TYPE text/html name 'tempfile,,id_info)
  return rcode
end 

oo=filespec('d',badipfile)||filespec('p',badipfile)||'OLD'
if dosisdir(oo)=0 then
  oo=filespec('d',badipfile)||filespec('p',badipfile)
oo=strip(oo,'t','\')||'\BADIP.???'
toydog=dostempname(oo)
foo=dosrename(badipfile,toydog)
if foo=1 then do
  call lineout tempfile,'<p>Old <tt>'host file'</tt> moved to <tt> 'toydog '</tt>'
end
else do
  call lineout tempfile,'<p>Error. Could not rename old <tt> 'badipfile '</tt> to <tt>'toydog'</tt>'
  call lineout tempfile,'</body></html>'
  CALL LINEOUT TEMPFILE
  rcode=sre_command('FILE nowait ERASE nowait TYPE text/html name 'tempfile,,id_info)
  return rcode
end


nzap=0
do mm=1 to lins.0
  if cleanup=1 then do
      aal=translate(strip(lins.mm))
      if abbrev(aal,'; REMOVED')=1 then do
         nzap=nzap+1
         iterate
      end
   end
   call lineout badipfile,lins.mm
end /* do */
call lineout badipfile

if nzap>0 then call lineout tempfile,'<p>'nzap ' inactivated entries cleaned up'


call lineout tempfile,'<p><b>'badipfile' </b> succesfully created.'
call lineout tempfile,'<p> <a href="/sre2k/srelite2/config.htm">back to configuration page</a>'

call lineout tempfile,'</body></html>'
call lineout tempfile

rcode=sre_command('FILE nowait ERASE  TYPE text/html name 'tempfile,,id_info)

foo=sre_flag_set('RESET',1)

return rcode


/***************/
/* load entries.!name  */
get_hosts:
badipfile=sre_value('UNALLOWED_FILE',,'SRESYS')
aa=sref_fileread(badipfile,'lins',,'E')
iat=0
do ii=1 to lins.0
   if  abbrev(strip(lins.ii),';')  then iterate
    if lins.ii=' ' then iterate
   iat=iat+1
   entries.iat.!name=strip(lins.ii)
end 
entries.0=iat
return iat


foo1:
call pmprintf("badipCFG error at " sigl ' ' rc)
foo=sre_command(string "badipCFG error at " sigl ' ' rc)
return foo

