/* srelite2 addon to Change SRE2003 Host information (HOSTINFO.CFG) */
hostcfg:

USECOLOR='2dd52f'

/* ---------------- DO NOT MODIFY BELOW THIS LINE  ------------------ */


parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,user,privset,,
          uri,host_nickname,id_info


if verb="" then do
   say " This sreLite2 add-on is NOT meant to be run from the command line."
   exit
end  

ss=sre_value('SECURITY_LEVEL',,'SRESYS')
if ss=0 then do
  foo=sre_command('String Sorry. Remote access to configuration utilities not permitted.',,idinfo)
  return foo
end
if ss=1 then do
    myaddr=sre_extract("clientaddr",idinfo)
    who=sre_extract("serveraddr",idinfo)
    if myaddr<>who then do
      sfoo=sre_command('String External (not-from-server-machine) web access to configuration utilities is not permitted' ,,idinfo)
      return sfoo
   end
end


signal on error name foo1 ; signal on syntax name foo1

crlf='0d0a'x
def_DIR=SRE_DATADIR()

list=strip(list)
list=sre_packur(translate(list,' ','+'||'090d0a'x))
if pos('TODO=__MODIFY',list)>0 then signal modifyit

/* else, show values */

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
call lineout tempfile, "<html><head><title>sreLite2 modify SRE2003 host entries </title>"
call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '
   
call lineout tempfile, "<h2> sreLite2: view and modify SRE2003 host entries       </h2> <p>"
call lineout tempfile,'<FORM method="POST" action="/system/hostCFG">'
call lineout tempfile,'<Input type="hidden" name="TODO" value="__MODIFY">'
call lineout tempfile,'<TABLE border=1><TR><th>Check to remove</th>'
call lineout tempfile,'<TH>Site Name <br>(domain name or IP address)</th><th>Host Nickname</th><TH>Default Data Directory </th>'

call get_hosts
do mm=1 to entries.0
 clickit='<input type="CHECKBOX" name="REMOVE" value="'entries.mm.!name'">'
   call lineout tempfile,'<tr><td align="center">'clickit'</td>'
   ddir=entries.mm.!dir
   call lineout tempfile,' <td>'entries.mm.!name '</td><td>'entries.mm.!nick'</td><td>'ddir'</td>'
end
call lineout tempfile,"<tr> <td colspan=4><hr>"
call lineout tempfile,'<tr bgcolor="#8998cc"><th>Add a new host:</th>'
call lineout tempfile,'<td><input type="text" name="NEWNAME" size=25></td>'
call lineout tempfile,'<td><input type="text" name="NEWNICK" size=15></td>'
call lineout tempfile,'<TD><input type="text" name="NEWDIR" size=30></td>'

call lineout tempfile,'</table>'
call lineout tempfile,'<input type="checkbox" name="CLEANUP" value=1>Cleanup hostinfo.cfg file (remove inactivated entries)'
call lineout tempfile,'<br><input type="SUBMIT" value="Modify host info"><input type="RESET">'
call lineout tempfile,'</form><br>'
call lineout tempfile,'Notes: <ul> <li> Host information is stored in: 'hostfile
call lineout tempfile,'<li> The default data directory is: 'def_dir

call lineout tempfile,'<li><a href="/sre2k/SRE2003.htm#appendix6" target="SRELITE2_DOC">The SRE2003 manual</a> '
call lineout tempfile,'<li><a href="/sre2k/srelite2/config.htm" >back to configuration page</a>'


call lineout tempfile,' </ul></body></html>'

CALL LINEOUT TEMPFILE
rcode=sre_command('FILE nowait  ERASE TYPE text/html name 'tempfile,,id_info)
return rcode


/* ---------jump here if "set values" chosen */
modifyit:
foo=sre_command('SET LIMITTIMETOTAL 50')
foo=sre_command('SET LIMITTIMEINACTIVE 40')

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
call lineout tempfile, "<html><head><title>sreLite2: modifying hosts </title>"
call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '
   
call lineout tempfile, "<h2> sreLite2: modifying host entries        </h2> <p>"

remlist=''
NEWNAME=''; newnick=''; newentry=0;newdir=''; cleanup=0
do until list=''
   parse var list a1 '&' list
   parse var  a1 avar '=' aval ;avar=strip(translate(avar))
   aval=strip(translate(sre_packur(aval),' ','+'||'0d0a00901'x))
   if aval='' then iterate
   if avar='REMOVE' then remlist=remlist' '||translate(aval)
   if avar='NEWNAME' & aval<>'' then do
       if words(aval)=1  then do                /* ignore if not 1 word */
          NEWNAME=aval
          newentry=1
       end
       else do
           call lineout tempfile,'<br>Can not process new entry: hostname must not contain spaces '
           newentry=0
       end 
   end
   if avar='NEWNICK' & aval<>'' then do
      if words(aval)<2  then do              /* ignore if not 1 word */
         newnick=strip(aval)
      end
       else do
         newentry=0             /* error, ignore this new host entry */
          call lineout tempfile,'<br>Can not process new entry: host nickname must not contain spaces '
       end 
   end 
   if avar='NEWDIR'  then do
      if aval='' then aval=def_dir        /* use default */
      newdir=translate(translate(strip(aval),' ','!'))
      newdir=strip(strip(newdir,,'\'))
      if right(newdir,1)=':' then newdir=newdir'\'
      if dosisdir(newdir)=0 then do
           call lineout tempfile,' <br>Can not process new entry: no such directory = ' newdir
           newentry=0
      end
   end
   if avar="CLEANUP" then cleanup=1
end /* do */

call get_hosts

/* remove entries */
nrem=0
do ii=1 to lins.0
   ss2=strip(lins.ii)
   if  abbrev(ss2,';')=1 then iterate
   if lins.ii=' ' then iterate
   parse var ss2  ahost ',' . ; ahost=strip(translate(ahost))
   if wordpos(ahost,remlist)>0 then do
        call lineout tempfile,' <br>Removing: <tt>'ahost'</tt>'
        lins.ii='; REMOVED '||date('u')||' - 'lins.ii
        nrem=nrem+1
   end 
end 
/* add an entry */

if newentry=1 then do
    if newnick='' | NEWNAME='' then do
       call lineout tempfile,'<br>Can not process new entry: You forgot to enter a hostname or a host nickname'
    end /* do */
    else do
       call lineout tempfile,'<br> Adding new entry for:<tt> 'NEWNAME'</tt>'
       iii=lins.0+1
       lins.iii=NEWNAME', 'newnick', 'newdir
       lins.0=iii
    end /* do */
end /* do */

/* no changes? */
if cleanup<>1 & newentry<>1 & nrem=0 then do
  call lineout tempfile,'<p>No changes were specified: host info file will not be modified. '
  call lineout tempfile,'</body></html>'
  CALL LINEOUT TEMPFILE
  rcode=sre_command('FILE nowait ERASE nowait TYPE text/html name 'tempfile,,id_info)
  return rcode
end 

oo=filespec('d',hostfile)||filespec('p',hostfile)||'OLD'
if dosisdir(oo)=0 then
  oo=filespec('d',hostfile)||filespec('p',hostfile)
oo=strip(oo,'t','\')||'\HOSTINFO.???'
toydog=dostempname(oo)
foo=dosrename(hostfile,toydog)
if foo=1 then do
  call lineout tempfile,'<p>Old <tt>'host file'</tt> moved to <tt> 'toydog '</tt>'
end
else do
  call lineout tempfile,'<p>Error. Could not rename old <tt> 'hostfile '</tt> to <tt>'toydog'</tt>'
  call lineout tempfile,'</body></html>'
  CALL LINEOUT TEMPFILE
  rcode=sre_command('FILE nowait ERASE nowait TYPE text/html name 'tempfile,,id_info)
  return rcode
end


nzap=0
do mm=1 to lins.0
  if cleanup=1 then do
      aal=translate(strip(lins.mm))
      if abbrev(aal,'; REMOVED')=1 then do
         nzap=nzap+1
         iterate
      end
   end
   call lineout hostfile,lins.mm
end /* do */
call lineout hostfile

if nzap>0 then call lineout tempfile,'<p>'nzap ' inactivated entries cleaned up'


call lineout tempfile,'<p><b>'hostfile' </b> succesfully created.'
call lineout tempfile,'<p> <a href="/sre2k/srelite2/config.htm">back to configuration page</a>'

call lineout tempfile,'<hr width="50%">'

foo=stream(hostfile,'c','close')

call lineout tempfile,'</body></html>'
call lineout tempfile

rcode=sre_command('FILE nowait ERASE  TYPE text/html name 'tempfile,,id_info)
foo=srel2_reset(1,,1)


return rcode


/***************/
/* load entries.!name .!nick and .!dir */
get_hosts:
hostfile=sre_value('HOSTFILE',,'SRESYS')
aa=sref_fileread(hostfile,'lins',,'E')
iat=0
do ii=1 to lins.0
   if  abbrev(strip(lins.ii),';')  then iterate
    if lins.ii=' ' then iterate
   iat=iat+1
   ss2=strip(lins.ii)
   parse var ss2 entries.iat.!name  ',' entries.iat.!nick ',' entries.iat.!dir
end 
entries.0=iat
return iat


foo1:
call pmprintf("hostCFG error at " sigl ' ' rc)
foo=sre_command(string "hostCFG error at " sigl ' ' rc)
return foo


