/* srelite2 addon to change srelite2 configuration file (SRELITE2.CFG)  */
optscfg:

USECOLOR='2dd52f'                       /* color used as body bgcolor */


/* ---------------- DO NOT MODIFY BELOW THIS LINE  ------------------ */


/* parse arg ddir,tempfile,sel,list,verb,uri,user,basedir,workdir,privset,
        enmadd,transaction,verbose   */

parse arg list,servername,verb,tempfile,,
          prog_file,reqnum,verbose,user,privset,,
          uri,host_nickname,id_info

if verb="" then do
   say " This sreLite2 add-on is NOT meant to be run from the command line."
   exit
end  

ss=sre_value('SECURITY_LEVEL',,'SRESYS')
if ss=0 then do
  foo=sre_command('String Sorry. Remote access to configuration utilities not permitted.',,id_info)
  return foo
end
if ss=1 then do
    myaddr=sre_extract("clientaddr",id_info)
    who=sre_extract("serveraddr",id_info)
    if myaddr<>who then do
      sfoo=sre_command('String External (not-from-server-machine) www access to configuration utilities is not permitted' ,,id_info)
      return sfoo
   end
end


signal on error name foo1 ; signal on syntax name foo1


crlf='0d0a'x
list=translate(list, ' ', '+'||'090a0d'x)  /* Whitespace, etc. */

addon_dir=sre_value('ADDON_DIR',,'SRE')

list=strip(list)
if pos('TODO=_MODIFY',sre_pACKUR(list))>0 then signal modifyit

/*  ======= show form of values */

call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
call lineout tempfile, "<html><head><title>sreLite2: view and modify parameters </title>"
call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '
   
call lineout tempfile,'<script language="javascript">'
call lineout tempfile,'var VU_OPEN=0;'
call lineout tempfile,'function Vu_doc(aloc) {'
call lineout tempfile,' if (VU_OPEN==0) {'
call lineout tempfile,'    daVIEWTREE=window.open("/sre2k/srelite2/srecfg1.htm","SRELITE2_DOC", "location=NO,MENUBAR=NO,RESIZABLE,DEPENDENT,SCROLLBARS=YES,STATUS=YES,TITLEBAR,TOOLBAR=NO,SCREENX=212,SCREENY=30,height=300,width=700");'
call lineout tempfile,'  };'
call lineout tempfile,'  VU_OPEN=1; daVIEWTREE.focus() ; '
call lineout tempfile,'  daVIEWTREE.location.hash=aloc ;'
call lineout tempfile,' return false ;}'
call lineout tempfile,' '
call lineout tempfile,' </script>'

call lineout tempfile, "<h2> sreLite2: view and modify configuration parameters   </h2> <p>"

inifile=sre_value('SREL2_INITFILE',,'SRE')
datetime=stream(inifile,'c','query datetime')
call lineout tempfile,'<em>' inifile ' last modified on 'datetime '</em><br>'


call lineout tempfile,'<FORM method="POST" action="/system/optsCFG">'
call lineout tempfile,'<Input type="hidden" name="TODO" value="_MODIFY">'
call lineout tempfile,'<TABLE border=1><TR><th>Check to<br>modify</th><TH>Parameter</th><th>current value</th>'

/* get parameters from file */
call get_parameters inifile

call lineout tempfile,'<tr>'
dolist=params.0
do forever
   if dolist='' then leave
   parse var dolist avar dolist
   avar=translate(strip(avar))
   if wordpos(avar,'SEL_REQUIRE REQUIRE REQUIRES')>0 then avar='SEL_REQUIRES'
   if wordpos(avar,'INHOUSEIP INHOUSE')>0 then avar='INHOUSEIPS'
   if wordpos(avar,'ALIAS')>0 then avar='ALIASES'
   if wordpos(avar,'LOAD_ADDONS')>0 then avar='LOAD_ADDON'
   aa='!'avar
   aval=params.aa
   call lineout tempfile,'<tr><td><input type="checkbox" name="MODIFY" value="'avar'"></td>'
   avarh=make_link(avar)
   call lineout tempfile,'<td><b>'avarh'</b></td>'
   oo=make_cell(avar,aval)
   call lineout tempfile,'<td>'oo'</td>'
end /* do */


call lineout tempfile,'</table> '

call lineout tempfile,'<input type="SUBMIT" value="Modify Parameters"><input type="RESET"></form>'

call lineout tempfile,'<hr width="50%">'
oo=sre_hostinfo('!INFO')
if oo<>'' then do
   call lineout tempfile,'<h4>Currently defined host_nicknames</h4>'
   call lineout tempfile,'<table border><tr><th>Host<br>Nickname <th>Domain<br>Name< th>Data <br>Directory'
   parse var oo . '0d0a'x  oo

   do until oo=''
      parse var oo aline '0d0a'x  oo
      if abbrev(strip(aline),'HOSTNAME_CACHE')=1 then iterate

      parse var aline nm ':' ahost ','  ddir '(' .
      call lineout tempfile,'<tr><th>'ahost'<td>'nm'<td>'ddir
   end
   call lineout tempfile,'<tr><td colspan=3> &nbsp; <tr bgcolor="#99ffee"><td colspan=3>'

     call lineout tempfile,' <b>Using Host-nicknames with <tt>SEL_REQUIRES, INHOUSEIPS,</tt> and <tt>ALIASES</tt> entries.</b><br>'
     call lineout tempfile,' <ul><li>To apply an entry to a specific host: preface the selector with <tt>host_Nickname//</tt>'
     call lineout tempfile,' <li>To apply an entry to <b>all</b>  hosts: preface the selector with <tt>*//</tt>'
     call lineout tempfile,' <li>To apply an entry to the generic host: do <b>not</b> preface the selector with <tt>//</tt>'
     call lineout tempfile,'</ul>'
    call lineout tempfile,'</table>'
end



call lineout tempfile,'<hr width="50%">'

call lineout tempfile,' <a href="/sre2k/srelite2/srecfg1.htm" '
call lineout tempfile,'  onCLick="Vu_doc('' '');  return false " '
call lineout tempfile,'  onMouseOut="window.status=''Configure sreLite2 options'' ; return true "  '
call lineout tempfile,'  onMouseOver="window.status=''View documentation in separate window'' ;return true">'
call lineout tempfile,'  Description of parameters</a> || '

call lineout tempfile,'<a href="/sre2k/srelite2/config.htm" >Return&nbsp;to&nbsp;sreLite2&nbsp;configuration&nbsp;page</a>'

call lineout tempfile,'</body></html>'
CALL LINEOUT TEMPFILE
foo=sre_command('FILE NOWAIT ERASE TYPE text/html name 'tempfile,,id_info)
return foo



/*=====  MODIFY (2nd step), given response from a form  */
modifyit:
call lineout tempfile, '<!doctype html public "-//IETF//DTD HTML 3.0//EN">'
call lineout tempfile, "<html><head><title>sreLite2: modifying parameters </title>"
call lineout tempfile, '</head><body  bgcolor="#'||usecolor||'"> '
   
call lineout tempfile, "<h2> sreLite2: modifying parameters        </h2> <p>"


/* get parameters from file */
call get_parameters

/* get parameters sent by the client. Note: only change those marked as MODIFY */
modlist=''
do until list=''
   parse var list a1 '&' list
   parse var  a1 avar '=' aval ;avar=strip(translate(avar))
   AVAL=sre_PACKUR(TRANSLATE(AVAL,' ','+'||'0D0A'X))
   avarx='!'avar
   vals.avarx=aval
   if avar='MODIFY' then modlist=modlist' '||strip(translate(AVAL))
end /* do */

if modlist='' then do
  call lineout tempfile,'<p>No changes, Configuration File will not be modified '
  call lineout tempfile,'<p><a href="/system/OPTSCFG?todo=SHOW">Redisplay parameters file </a>'
  call lineout tempfile,'</body></html>'
  CALL LINEOUT TEMPFILE
  foo=sre_command('FILE NOWAIT ERASE TYPE text/html name 'tempfile,,id_info)
  return foo
end

/* Create a backup */

oo=filespec('d',inifile)||filespec('p',inifile)||'OLD'
if dosisdir(oo)=0 then
  oo=filespec('d',inifile)||filespec('p',inifile)
oo=strip(oo,'t','\')||'\SRELITE2.???'

toydog=dostempname(oo)
foo=dosrename(inifile,toydog)


if foo=1 then do
  call lineout tempfile,'<p>Old <tt>'inifile'</tt> moved to <tt> 'toydog '</tt>'
end
else do
  call lineout tempfile,'<p>Error. Could not rename old <tt> 'inifile '</tt> to <tt>'toydog'</tt>'
  call lineout tempfile,'</body></html>'
  call lineout tempfile
  foo=sre_command('FILE NOWAIT ERASE TYPE text/html name 'tempfile,,id_info)
  return foo
end

didlist=''
didlastmod=0
oldmodlist=modlist

 call lineout tempfile,'<br>'

/* modify values... */
do mm=1 to lins.0
  acomment=''
  alin=strip(lins.mm)
  if alin='' | abbrev(alin,';')=1 then do
     if abbrev(alin,';last-modified:')=1 then do
        alin=';last-modified: '||date('n')||' '||time('n')
        didlastmod=1
     end 
  /*   if abbrev(aline,';//')=0 then   -- need to debug this first */
     call lineout inifile,alin
     iterate
  end /* do */
  parse var alin avar0 '=' aval0
  avar0=strip(translate(avar0))
  if wordpos(avar0,didlist)>0 then iterate

  ido=wordpos(avar0,modlist)
  if ido=0 then do
     call lineout inifile,alin
     iterate
  end /* do */

/* if here, this is variable has been given a new value */

  avarx='!'avar0
  vv=vals.avarx

/* a few quality controls */
  if avar0='SUPERUSERS' & vv<>"" then do
      tu=fix_superusers(vv)
      if abbrev(tu,'WARNING')>0 then do
          call lineout tempfile,'<br>'tu
          vv=aval0
      end
      else do
         vv=tu
      end
  end

/* now write to cfg file */
  if vv='' then do
      call lineout inifile,avar0 ' = '||vv
  end
  else do

    do until vv=''
      parse var  vv avv '0d0a'x vv
      if avar0='INHOUSEIPS' then do             /* dns lookup needed? */
          parse var avv d1 d2
          tu=fix_inhouseip(d1)
          select 
            when abbrev(tu,'WARNING')>0 then do
              call lineout tempfile,'<br>'tu
              avv=' ' 
              call lineout  inifile,'; 'acomment
             end
             when tu<>'' then do
                avv=tu' 'd2
                call lineout  inifile,'; 'acomment
             end
             otherwise
                nop
             end
            acomment=''
      end                       /* inhouseips */

      if avv<>'' then call lineout inifile,avar0 ' = '||avv

    end         /* until vv='' */
  end
  didlist=didlist' 'avar0
  modlist=delword(modlist,ido,1)
  if acommment<>'' then call lineout  inifile,'; 'acomment

end 

/* some info to the client ... */
call lineout tempfile,'<p> '||words(oldmodlist)||' parameters were modified: '
call lineout tempfile,'<blockquote><tt>'||oldmodlist||'</tt></blockquote>'

if modlist<>'' then do
  call lineout tempfile,'<br> '||words(modlist)||' new parameters were added: '
  call lineout tempfile,'<blockquote><tt>'||modlist||'</tt></blockquote>'
end


/* these are items that were chosen to be modified by the client, but
   that did not exist in the inifile. So write them out now. */

if modlist<>'' then do
   call lineout inifile,'; new additions on 'date('n')
   do forever
       if modlist='' then leave
       parse var modlist avar modlist
       avar0=strip(avar)
       avarx='!'avar0
       call lineout inifile,avar0 ' = '||vals.avarx 
   end /* do */
end /* do */

if didlastmode=0 then do
     call lineout inifile,' '
     alin=';last-modified: '||date('n')||' '||time('n')
     call lineout inifile,alin
end

call lineout inifile
foo=srel2_reset()

call lineout tempfile,'<p><b>'inifile' </b> succesfully created'
call lineout tempfile,'<p><a href="/system/OPTSCFG?todo=SHOW">Redisplay parameters file </a>'
call lineout tempfile,'</body></html>'
CALL LINEOUT TEMPFILE
foo=sre_command('FILE NOWAIT ERASE TYPE text/html name 'tempfile,,id_info)
return foo



/***************/
/* load entries.!user .!pwd and .!privs */
get_parameters:
parse arg inifile

if inifile='' then inifile=sre_value('SREL2_INITFILE',,'SRE')
stuff=sre_read_file(inifile,2,2)
if stuff='' then signal foo2  /* error */

crlf='0d0a'x
params.=''
lins.0=0;ill=0
do forever
   if stuff='' then leave
   parse var stuff aline (crlf) stuff
   ill=ill+1
   lins.ill=aline
   lins.0=ill
   aline=strip(aline)
   if aline='' then iterate
   if abbrev(aline,';')=1 then iterate
   parse var aline  avar '=' aval
   avar=space(translate(avar),0)
   aval=strip(aval)
   if avar='' then iterate      /* bad value */
   if aval='' then aval="' '"
   a1=left(aval,1)
   if a1='"' | a1="'" then aval=strip(aval,,a1)
   aa='!'avar
   if params.aa<>'' then
      params.aa=params.aa||'0d0a'x||aval
   else
      params.aa=aval
   if wordpos(avar,params.0)=0 then params.0=params.0' 'avar
end

return 1


foo1:
foo=sre_pmprintf("optsCFG error at " sigl ' ' rc)
foo=sre_command("string optsCFG error at " sigl ' ' rc,,id_info)


foo2:
foo=sre_pmprintf('optsCFG  could not find initialization file  'inifile)
foo=sre_command('string optsCFG error no initialization file ',,id_info)


exit

/*****/
/* make a link to doc file, for a param name */
make_link:procedure
parse arg aa
aloc="'"||lower(aa)||"'"
bb='onClick="Vu_doc('||aloc||');  return false " '

na='<a href="/sre2k/srelite2/srecfg1.htm#'||lower(aa)||'" target="SRELITE2_DOC" 'bb'>'AA'</a>'
return na

/*********************/
/* fix superusers value */
fix_superusers:procedure expose acomment
parse arg newname

didcvt=0
nn=''
do jj=1 to words(newname)
  a1=strip(word(newname,jj))
  if pos('*',a1)>0 then do
      return 'WARNING. SUPERUSER not specified correctly: * (wildcard) not allowed  -- <tt>'a1'</tt>'
  end
  if verify(a1,'1234567890.')>0 then do
      rc=sockgethostbyname(a1, "serv.0")  /* get dotaddress of server */
      if serv.0addr='SERV.0ADDR' then do
         return 'WARNING. SUPERUSER entry could not be found: dns lookup failed for domain name = 'a1
      end 
      nn=nn' 'serv.0addr
      didcvt=1
  end
  else do
      nn=nn' 'a1
  end
end
if didcvt=1 then  acomment=' (domain names converted from '||newname

return nn          /* okay to use this entry */


/*********************/
/* fix superusers value */
fix_inhouseip:procedure expose acomment
parse arg newname

didcvt=0
nn=''
do jj=1 to words(newname)
  a1=strip(word(newname,jj))
  if verify(a1,'1234567890*.')>0 then do
      rc=sockgethostbyname(a1, "serv.0")  /* get dotaddress of server */
      if serv.0addr='SERV.0ADDR' then do
         acomment=' unable to use INHOUSEIPS = 'a1
         return 'WARNING. INHOUSEIPS entry could not be found: dns lookup failed for domain name = 'a1
      end 
      nn=nn' 'serv.0addr
      acomment=' Converted from 'a1
      didcvt=1
  end
  else do
      nn=nn' 'a1
  end
end
if didcvt=1 then  acomment=' ('nn' converted from '||newname

return nn          /* okay to use this entry */



/*********************/
/* make an input cell */
make_cell:procedure expose id_info addon_dir
parse arg avarx,avalx
avarx=strip(translate(avarx))
select
   when avarX='ACCEPT_RANGE' then DO
      AA=make_radios(2,avalx,avarx,0,"Disable",1,"Enable")
   END

   when avarX='ADD_SLASH' then DO
      AA=make_radios(2,avalx,avarx,0,"Disable",1,"Enable")
   END


   WHEN AVARX='ALWAYS_GET_PRIVS' THEN DO
       AA=MAKE_RADIOS(3,AVALX,AVARX,0,'Check if necessary',1,'Always check',2,'Always check, ask if necessary')
   end

   when avarX='LOGIT' then DO
/* Common log option. 0=no, 1=short, 2=long, 3=long+referer+browser */
      AA=make_radios(4,avalx,avarx,0,"Do <b>not</b> record to log file",1,"Short record ",,
                                   2,"Long record ", ,
                                   3,'Long&nbsp;record&nbsp;&amp;&nbsp;referer&nbsp;&amp;&nbsp;browser&nbsp;info')
   END

   when avarX='DOMD5' then DO
      AA=make_radios(2,avalx,avarx,0,"do NOT add Content-MD5 response header",1,"Add Content-MD5 respond header ")
   END


   when avarx='CHECK_SLASHS' then do
       aa=make_radios(2,avalx,avarx,0,'Disable',1,'Enable')
   end /* do */


   when avarx='RECORD_ALL' then do
       aa=make_radios(3,avalx,avarx,0,'Disable',1,'Enable',2,'Enable for all, including ?xxx')
   end /* do */

   when avarx='DEFAULT_REQUIRES' then do
        aa='Default required privileges '||'<input type="text" size=38 name="'avarx'" value="'avalx'">'
   end


   when avarx='GZIP_THESE' then do
      aa='Enable on-the-fly GZIP (as a transfer-encoding)<br><b>0</b> Disable <br> '
      aa=aa||'<b>1</b> Enable <br> '
      aa=aa||'<B>1 exts_list </b> Enable, but not for files with an extension in exts_list <br>'
      aa=aa||'<input type="text" size=25 name="'avarx'" value="'avalx'">' 
   end

   when avarx='ALIASES' then do
      aa='One alias per line, structured as:<br> <tt>old_selector new_selector </tt>  <br>'
      aa=aa||'<textarea cols=60 rows=4 name="'avarx'">'||avalx||'</textarea>' 
      aa=aa||'<br><em>Note:</em> on multi-host systems, <tt>old_selector</tt> may ',
      'start with a <tt>host_nickname//</tt>'

   end

   when avarx='INHOUSEIPS' then do
      aa='One in-house IP address per line, structured as: <br><tt>ip_address optional_priv_list </tt><br>'
      aa=aa||'<textarea cols=60 rows=4 name="'avarx'">'||avalx||'</textarea>' 
      aa=aa||'<br><em>Notes:</em><br> *  on multi-host systems, <tt>ip_address</tt> may start with a <tt>host_nickname//</tt>'
      aa=aa||'<br> * dotted numeric IP addresses may contain * wildcards, domain-name IP addresses can <b>not</b> contain *  <br>'


   end

   when avarx='SEL_REQUIRES'  then do
      aa='One selector-requirement  per line, structured as: <br><tt>selector required_privs , quick_file , no_log , realm_name </tt>  <br>'
      aa=aa||'<textarea cols=60 rows=4 name="'avarx'">'||avalx||'</textarea>' 
      aa=aa||'<br><em>Note:</em> on multi-host systems, <tt>selector</tt> may ',
      'start with a <tt>host_nickname//</tt>'
   end

   when avarx='LOAD_ADDON'  then do
      aa='One addon per line, structured as: <br><tt>addon_selector filename</tt>  <br>'
      aa=aa||'<textarea cols=60 rows=4 name="'avarx'">'||avalx||'</textarea>' 
      aa=aa||'<br><em>Note:</em> file name can be fully qualified, or relative to <tt> '||addon_dir'</tt>'
   end


   when avarx='DIR_EXCLUSION' then do
        aa='!DIR directory listing will not display these files and subdirectories:<br>'||'<input type="text" size=53 name="'avarx'" value="'avalx'">'
   end


   when avarx='NOT_FOUND_FILE' then do
        aa='A 404 response file (0=use generic response)= '||'<input type="text" size=20 name="'avarx'" value="'avalx'">'
   end

   when avarx='POST_FILTER' then do
        aa='Post Filter procedure (0=none) '||'<input type="text" size=23 name="'avarx'" value="'avalx'">'
   end

   when avarx='VERBOSE' then do
       aa=make_radios(3,avalx,avarx,0,'Errors Only',1,'CommonLog output',2,'Status Messages')
   end /* do */

   when avarx='SUPERUSERS' then do
        aa='List of IP addresses (numeric or domain name) granted SUPERUSER privileges (* wildcards can be used)<br> '||'<input type="text" size=53 name="'avarx'" value="'avalx'">'
   end

   when avarx="REALM" then do
        aa='Default Realm Name: '||'<input type="text" size=27 name="'avarx'" value="'avalx'">'

   end /* do */

   when avarx="HOME_DIR" then do
        aa='User-home directory (the ~ root): '||'<input type="text" size=27 name="'avarx'" value="'avalx'">'
   end /* do */

   when avarx='SSI_EXTENSIONS' then do
        aa='Server Side Include Extensions: '||'<input type="text" size=36 name="'avarx'" value="'avalx'">'
   end

   when avarx='DEFAULTS' then do
        aa='Default files to look for (!DIR means "display directory"):<br> '||'<input type="text" size=50 name="'avarx'" value="'avalx'">'
   end


   otherwise do
       aa='<Input type="text" name="'avarx'" size=80 value="'avalx'">'
   end
end  /* select */
return aa






/********************************************/
/* --- create a row of radio buttons */
make_radioS:procedure
parse arg ndo,curval,thename
aa=''

do mm=1 to ndo
 MM2=MM*2
 thisval=arg(mm2+3-1)
 thisopt=arg(mm2+3)
 aa=aa||'<input type="radio" name="'thename'" '
 if curval=thisval then aa=aa||' CHECKED '
 aa=aa||'value="'thisval'" >'thisopt' '
 IF MM<NDO then AA=AA||' || '
end /* do */
RETURN AA


